package com.eactive.eai.batch.job.jobItem.house;

import java.io.ByteArrayOutputStream;
import java.util.Properties;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.batch.common.LogUtil;
import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_HOUSE_0330 extends DefaultTelegram implements TelegramService {

	private int REAL_BYTE;      // 실 data byte수
    private int SEND_LENGTH;        //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이
    private String recvTelegramBody;
    private Properties telegramInfo;

    /**
     * 생성자
     */
    public SEND_HOUSE_0330() {
        // HEADER/TRAILER 수신 보고
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {

        	recvTelegramBody = new String(batchDoc.getBatchMsg().getTelegramBody());
        	
            REAL_BYTE = recvTelegramBody.length() - 11;
        	
            boolean result = calculateSendLength();
            if (!result) return false;
            
            //아데나 장비를 위한 전문 길이 필드
            compileField(0, ""+SEND_LENGTH, this.al_FieldProps[0]);

            //Transaction Code - 해당 Transaction을 기동하는 코드. LU가 구분 되어 있을 것으로 예상
            // 모기지론 유동화 자료 - HR00FTP
            // 주택위탁보증 자료     - HW00FTP
            // 학자금 유동화 자료    - SR00FTP
            // 학자금위탁보증 자료  - SW00FTP
            // U보금자리                 - BM00FTP/BM01FTP
            compileField(1, batchDoc.getBatchMsg().getHeader().getTRXID(), this.al_FieldProps[1]);
            
            //업무구분코드 - 업무구분을 위하여 Set하는 문자로 본 파일전송 업무에서는 “FTP”문자를 사용키로 한다.
            compileField(2, telegramInfo.getProperty(TelegramKeys.BIZ_GBN), this.al_FieldProps[2]);
            
            //대표기관코드 - 전문관련 대외기관을 나타내는 코드로서 세부사항은 표준화 사항의 대외기관코드를 참조한다.
            // Ex) 국민: 004, 부산: 032, 농협: 011 등
            compileField(3, telegramInfo.getProperty(TelegramKeys.BANK_CODE), this.al_FieldProps[3]);
            
            //전문종별코드 - 전문의 기능을 나타내는 구분코드로 전문종류별로 해당 전문코드를 Set하며 세부사항은 표준화 사항의 전문종별 코드를 참조한다.
            compileField(4, this.getFldTelegramType(), this.al_FieldProps[4]);
            
            //거래구분코드 - 각 업무 및 화일의 종류를 구분하기 위한 코드로 구성되며 세부내용은 표준화 사항을 참조한다.
            compileField(5, batchDoc.getBatchMsg().getHeader().getBizCode(), this.al_FieldProps[5]);

            //송수신 FLAG - 전문을 발생시킨 기관을 나타내는 코드로 아래의 값중 해당코드를 Set한다.
            // “C” : 한국주택금융공사에서 전문을 발생할 시
            // “B” : 위탁기관에서 전문을 발생할 시
            compileField(6, telegramInfo.getProperty(TelegramKeys.TRA_FLAG_BANK), this.al_FieldProps[6]);
            
            //응답코드 - 전문의 처리 결과를 나타내는 응답코드로 세부내용은 표준화 사항의 응답코드를 참조한다.
            compileField(7, this.getResolveResponseCode(), this.al_FieldProps[7]);
            
            //일자 (자료기준일자) - 은행에서 자료보고(위탁기관→주택금융공사) 및 주택금융공사자료통보(주택금융공사→위탁기관) 시에는 자료의 기준일자를 Set한다.
            compileField(8, batchDoc.getBatchMsg().getHeader().getBaseDate(), this.al_FieldProps[8]);
            
            //업무별 Record Length -송수신을 하고자 하는 자료의 Record Length를 Set 한다.
            compileField(9, ""+batchDoc.getBatchMsg().getHeader().getRecLen(), this.al_FieldProps[9]);
            
            //전체 전문 길이
            //공통부와 업무정보부를 합한  전체길이.
            //프로토콜이 TCP/IP 인 경우만 Set 한다.
            //compileField(10, ""+SEND_LENGTH, this.al_FieldProps[10]);
            compileField(10, "0", this.al_FieldProps[10]);
            
            //송수신 업무 구분코드. 한국주택금융공사를 기준으로 하여 해당전문이 송.수신업무 중 어느 업무에 관련된 것인지를 구분하기 위한 코드로 아래값 중 해당코드를 Set한다.
            //“S”  :  화일 송신업무 관련 전문 (한국주택금융공사→위탁기관)
            //“R”  :  화일 수신업무 관련 전문 (위탁기관→한국주택금융공사)
            compileField(11, getFldTrClass() , this.al_FieldProps[11]);

            //Block-NO
            compileField(12, ""+this.batchDoc.getBatchMsg().getBody().getBlockNum() , this.al_FieldProps[12]);

            //Sequence-NO
            compileField(13, ""+this.batchDoc.getBatchMsg().getBody().getSeqNum() , this.al_FieldProps[13]);

            //Record 수 --받은 내용을 그대로 돌려 보내기
            compileField(14, recvTelegramBody.substring(8,11), this.al_FieldProps[14]);

            //<< 전문 완성
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }


    public boolean doPostExecute() {
        try {
            if (!super.doPostExecute()) return false;

			//DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<11; i++) { //한국주택금융공사 전문의 헤더는 레코드 길이까지 임.
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=11; i< al_Field.size(); i++) {  //결번확인 필드는 비정형 필드로 바디 로그에서 제외
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));
            
            String _block_no = new String ((byte[]) al_Field.get(12));
            int recv_block_no = Integer.parseInt(_block_no);

            long lnCurSize = batchDoc.getBatchMsg().getBody().getCurFileSize()+ REAL_BYTE;
            batchDoc.getBatchMsg().getBody().setCurFileSize(lnCurSize);

            if( recv_block_no == 0 ) {
                LogUtil.setLogFileStart(batchDoc);
                batchDoc.getBatchMsg().getBody().setBlockNum(1);
            } else if ( recv_block_no == 9999 ) {
                batchDoc.getBatchMsg().getHeader().setFileSize(batchDoc.getBatchMsg().getBody().getCurFileSize());
                int recLen = batchDoc.getBatchMsg().getHeader().getRecLen();
                if ( recLen > 0 ){
                	int recCnt = (int)batchDoc.getBatchMsg().getBody().getCurFileSize()/recLen;
                	batchDoc.getBatchMsg().getHeader().setTotRecCnt(recCnt);
                }
            	LogUtil.setLogFileEnd(batchDoc);
            }

            return true;

        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPreExecute() {
    	try {
            if (!super.doPreExecute()) return false;
            telegramInfo = getTelegramInfo();
            return true;
    	} catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    /**
     * 비정형 필드에 대한 송신 길이를 계산해서 리턴해준다.
     *
     * 필드(idx)가 비정형 필드(XX)인지 점검하고 , 해당 필드에 대한 예상 길이를 계산하여 리턴하도록 한다
     *
     * 비정형 필드를 가지고 있는 개별 Telegram Class 에서 오버라이드 필요.
     */
    public int getCalculatedLength(int idx) {
        try {
            if (idx >= this.getFieldCount() ) {
                logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
                //여기에서 파일을 연다.
               return REAL_BYTE;
            } else {
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI012";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                logger.debug("{} getCalculatedLength> parameter is not FIELD_NO_LENGTH", logHeader);
                return -1;
            }
        }catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI005";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }



    private boolean calculateSendLength () {
        try {
            for (int i=1; i< this.al_Field.size()-1; i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            SEND_LENGTH += REAL_BYTE;
            REAL_SEND_LENGTH = SEND_LENGTH;
            REAL_SEND_LENGTH += ((byte[]) this.al_Field.get(0)).length;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    public int getInformalFieldSendData(int idx, byte[] data) {
        try {
            if (idx >= this.getFieldCount() ) {
                logger.debug("{}  getInformalFieldSendData> " +idx+ " is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (data.length < REAL_BYTE) {
                logger.debug("{}  getInformalFieldSendData> InformalFieldSendData size is bigger than buffer size", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI014";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }

//            bin.read(data, 0, REAL_BYTE);
            System.arraycopy(recvTelegramBody.getBytes(), 11, data, 0, REAL_BYTE );
            
            // 20060419 add by khs for 전송상태 확인
//            long lnCurSize = batchDoc.getBatchMsg().getBody().getCurFileSize() + REAL_BYTE;
//            batchDoc.getBatchMsg().getBody().setCurFileSize(lnCurSize);

            return REAL_BYTE;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI006";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return -1;
        }
    }
    

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
		return super.getFieldValueString(4);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
		return super.getFieldValueString(11);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
		return super.getFieldValueString(7);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
		return super.getOpCode();
    }
}
